import java.util.Arrays;

public abstract class Thief {

    private char[] characters ;
    private char[] password;
    
    private boolean initialized = false;
    private boolean opened = false;

    public abstract void breakPassword(int sizeOfPassword);
    
    public boolean tryOpen(char[] password) {
        if (this.password.length != password.length) {
            throw new IllegalArgumentException("Given password must be of the "
                    + "same size as password of the vault ("+ this.password.length
                    + "), but was: "+ password.length);
        }
        
        opened = Arrays.equals(this.password, password);
        
        if (opened) {
            StringBuilder sb = new StringBuilder();
            for (char c : password) {
                sb.append(c);
            }
            
            System.out.println("[VAULT] opened, password is "+ sb.toString());
        }
        
        return opened;        
    }
    
    public char[] getCharacters() {
        return characters;
    }
    
    public final void init(char[] characters, String passwordString) {
        if (initialized) {
            throw new IllegalStateException("Function init has already been called");
        }
        initialized = true;
        
        this.characters = Arrays.copyOf(characters, characters.length);
        this.password = passwordString.toCharArray();
        
        Arrays.sort(characters);
        
        for (char c : password) {
            if (Arrays.binarySearch(characters, c) < 0) {
                throw new IllegalArgumentException("Password must contain only "
                        + "characters from character set");
            }
        }
    }

    boolean isOpened() {
        return opened;
    }
}
